pro count_map
slim=14 ; Set sample limit to 0 for normal, or 14 if doing rarefaction. Remember also to change gstring() to gstring_rare() if doing rarefaction.
;
;Read in data
openr,1,'data/mdiv_patch.dat'
data=dblarr(14,83213)
readf,1,data
close,1

openr,1,'data/gnames.dat'
;openr,1,'data/spnames.dat'
taxa=strarr(1,83213)
readf,1,taxa
close,1
;
; increments of epochs
;age_size=[-1,1455,12823,22126,52897,62358,82040]
;iname=['holocene','pleistocene','pliocene','miocene','oligocene','eocene']
; increments of sub-epochs
;iname=['holocene','pleistocene','pliocene','late_miocene','middle_miocene','early_miocene','late_oligocene','early_oligocene','late_eocene','middle_eocene','early_eocene']
;age_size=[-1,1455,12823,22126,29681,42967,52897,55703,62358,70633,79115,82040]
; SKIP THE HOLOCENE B/C NOT ENOUGH OBSERVATIONS TO DO RAREFACTION
age_size=[1455,12823,22126,29681,42967,52897,55703,62358,70633,79115,82040]
iname=['pleistocene','pliocene','late_miocene','middle_miocene','early_miocene','late_oligocene','early_oligocene','late_eocene','middle_eocene','early_eocene']
; step size
stsz=1
;
; the total number of degrees
nlon=360L
nlat=180L
;
set_plot,'z'
loadct,27
tvlct,RedTab,GreenTab,BlueTab,/get
RedTab(1)=0
GreenTab(1)=0
BlueTab(1)=0
tvlct,RedTab,GreenTab,BlueTab
device,set_font='Helvetica Bold',/tt_font,set_character_size=[48,36],set_graphics_function=3L,set_resolution=[2000,2000],z_buffering=0
;
num=0
;for i=0,10 do begin
for i=0,9 do begin
   print,'Searching '+iname[num]
   lat=data[ 1,age_size[num]+1:age_size[num+stsz]+1 ]
   lon=data[ 2,age_size[num]+1:age_size[num+stsz]+1 ]
   ;clust_num_40=data[ 10,age_size[num]+1:age_size[num+stsz]+1 ]
   names=taxa[ 0,age_size[num]+1:age_size[num+stsz]+1 ]
   ;
   x=dindgen(nlon)-179.5
   y=dindgen(nlat)-89.5
   tc=lonarr(nlon,nlat)
   ;;; define pointer tctmp that will point to a string vector
   ;;; declare and allocate 2d array for depositional habitats
   ;hab40=lonarr(nlon,nlat)
   for mlon=0,nlon-1 do begin
      for mlat=0,nlat-1 do begin
   ;         print,x[mlon],y[mlon]
         ttmp = gstring_rare(lon,lat,names,x[mlon],y[mlat])
         ;;;specify clust_num index with variable ctemp avoid syntax problems
         ;;;tc is the number of unique genus/class names
         idx=where(lat ge y[mlat]-0.5 and lat lt y[mlat]+0.5 and lon ge x[mlon]-0.5 and lon lt x[mlon]+0.5,cnt)
         if cnt gt slim then begin
            tc[mlon,mlat]=n_elements(ttmp)
         endif else begin
            ; If no data in this gridcell, set tc to zero.
            tc[mlon,mlat] = 0
         endelse
      endfor ; mlat
   endfor ; mlon
   ; declare the range of tc to pass to map_legend_count_map.
   tmin = min(tc[where(tc gt 0)])
   tmax = max(tc[where(tc gt 0)])
   ;
   tv_data=bytscl(tc,max=tmax,min=tmin,top=251)+3
   idx = where(tc eq 0,cnt)
   if cnt gt 0 then tv_data[idx] = 255
   ;
   ; Alpha Diversity Western Europe
   tc_eur=tc[170:200,120:150] ;30N:60N, 10W:20E. note that mlon is 0:360, mlat is 0:180
   eur_mean=mean(tc_eur[where(tc_eur gt 0)])
   print,'eur adiv:'+strtrim(string(eur_mean,format='(F0.1)'),2)
   map_set,0,0,0,/isotropic,ymargin=[8,2],limit=[30,-10,60,20],color=1,/noborder
   result=map_patch(tv_data,x,y,/triangulate,max_value=254,missing=0,xstart=x0,xsize=xs,ystart=y0,ysize=ys)
   tv,result,x0,y0
   map_continents,/coasts,/countries,color=1,thick=8,fill_continents=2,mlinestyle=2,mlinethick=2,orientation=135
   map_legend_count_map,tmin,tmax
   ;
   map=tvrd()
   write_gif,'images/count_map_adiv_eur_'+iname[num]+'.gif',map,RedTab,GreenTab,BlueTab
   ;write_gif,'images/species/count_map_adiv_eur_'+iname[num]+'.gif',map,RedTab,GreenTab,BlueTab
   ;
   ; Alpha Diversity Japan
   tc_jpn=tc[300:330,117:147] ;27N:57N, 120E:150E. note that mlon is 0:360, mlat is 0:180
   jpn_mean=mean(tc_jpn[where(tc_jpn gt 0)])
   print,'jpn adiv:'+strtrim(string(jpn_mean,format='(F0.1)'),2)
   map_set,0,0,0,/isotropic,ymargin=[8,2],limit=[27,120,57,150],color=1,/noborder
   result=map_patch(tv_data,x,y,/triangulate,max_value=254,missing=0,xstart=x0,xsize=xs,ystart=y0,ysize=ys)
   tv,result,x0,y0
   map_continents,/coasts,/countries,color=1,thick=8,fill_continents=2,mlinestyle=2,mlinethick=2,orientation=135
   ;map_horizon,color=1
   map_legend_count_map,tmin,tmax
   ;
   map=tvrd()
   write_gif,'images/count_map_adiv_jpn_'+iname[num]+'.gif',map,RedTab,GreenTab,BlueTab
   ;write_gif,'images/species/count_map_adiv_jpn_'+iname[num]+'.gif',map,RedTab,GreenTab,BlueTab
   ;
   ; Alpha Diversity Southeastern US
   tc_nam=tc[83:113,110:140] ;20N:50N, 97W:67W. note that mlon is 0:360, mlat is 0:180
   nam_mean=mean(tc_nam[where(tc_nam gt 0)])
   print,'nam adiv:'+strtrim(string(nam_mean,format='(F0.1)'),2)
   map_set,0,0,0,/isotropic,ymargin=[8,2],limit=[20,-97,50,-67],color=1,/noborder
   result=map_patch(tv_data,x,y,/triangulate,max_value=254,missing=0,xstart=x0,xsize=xs,ystart=y0,ysize=ys)
   tv,result,x0,y0
   map_continents,/coasts,/countries,/usa,color=1,thick=8,fill_continents=2,mlinestyle=2,mlinethick=2,orientation=135
   map_legend_count_map,tmin,tmax
   ;
   map=tvrd()
   write_gif,'images/count_map_adiv_nam_'+iname[num]+'.gif',map,RedTab,GreenTab,BlueTab
   ;write_gif,'images/species/count_map_adiv_nam_'+iname[num]+'.gif',map,RedTab,GreenTab,BlueTab
   ;
   num=num+1
   print,''
endfor
;
;Do entire Cenozoic
lat=data[ 1,* ]
lon=data[ 2,* ]
names=taxa[ 0,* ]
;
x=dindgen(nlon)-179.5
y=dindgen(nlat)-89.5
tc=lonarr(nlon,nlat)
;;; define pointer tctmp that will point to a string vector
;;; declare and allocate 2d array for depositional habitats
;hab40=lonarr(nlon,nlat)
for mlon=0,nlon-1 do begin
   for mlat=0,nlat-1 do begin
;         print,x[mlon],y[mlon]
      ttmp = gstring(lon,lat,names,x[mlon],y[mlat])
      ;;;specify clust_num index with variable ctemp avoid syntax problems
      ;;;tc is the number of unique genus/class names
      idx=where(lat ge y[mlat]-0.5 and lat lt y[mlat]+0.5 and lon ge x[mlon]-0.5 and lon lt x[mlon]+0.5,cnt)
      if cnt gt slim then begin
         tc[mlon,mlat]=n_elements(ttmp)
      endif else begin
         ; If no data in this gridcell, set tc to zero.
         tc[mlon,mlat] = 0
      endelse
   endfor ; mlat
endfor ; mlon
; declare the range of tc to pass to map_legend_count_map.
tmin = min(tc[where(tc gt 0)])
tmax = max(tc[where(tc gt 0)])
;
tv_data=bytscl(tc,max=tmax,min=tmin,top=251)+3
idx = where(tc eq 0,cnt)
if cnt gt 0 then tv_data[idx] = 255
;
; Alpha Diversity Western Europe
map_set,0,0,0,/isotropic,ymargin=[8,2],limit=[30,-10,60,20],color=1,/noborder
result=map_patch(tv_data,x,y,/triangulate,max_value=254,missing=0,xstart=x0,xsize=xs,ystart=y0,ysize=ys)
tv,result,x0,y0
map_continents,/coasts,/countries,color=1,thick=8,fill_continents=2,mlinestyle=2,mlinethick=2,orientation=135
map_legend_count_map,tmin,tmax
;
map=tvrd()
write_gif,'images/count_map_adiv_eur.gif',map,RedTab,GreenTab,BlueTab
;write_gif,'images/species/count_map_adiv_eur.gif',map,RedTab,GreenTab,BlueTab
;
; Alpha Diversity Japan
map_set,0,0,0,/isotropic,ymargin=[8,2],limit=[27,120,57,150],color=1,/noborder
result=map_patch(tv_data,x,y,/triangulate,max_value=254,missing=0,xstart=x0,xsize=xs,ystart=y0,ysize=ys)
tv,result,x0,y0
map_continents,/coasts,/countries,color=1,thick=8,fill_continents=2,mlinestyle=2,mlinethick=2,orientation=135
;map_horizon,color=1
map_legend_count_map,tmin,tmax
;
map=tvrd()
write_gif,'images/count_map_adiv_jpn.gif',map,RedTab,GreenTab,BlueTab
;write_gif,'images/species/count_map_adiv_jpn.gif',map,RedTab,GreenTab,BlueTab
;
; Alpha Diversity Southeastern US
map_set,0,0,0,/isotropic,ymargin=[8,2],limit=[20,-97,50,-67],color=1,/noborder
result=map_patch(tv_data,x,y,/triangulate,max_value=254,missing=0,xstart=x0,xsize=xs,ystart=y0,ysize=ys)
tv,result,x0,y0
map_continents,/coasts,/countries,/usa,color=1,thick=8,fill_continents=2,mlinestyle=2,mlinethick=2,orientation=135
map_legend_count_map,tmin,tmax
;
map=tvrd()
write_gif,'images/count_map_adiv_nam.gif',map,RedTab,GreenTab,BlueTab
;write_gif,'images/species/count_map_adiv_nam.gif',map,RedTab,GreenTab,BlueTab
;
;
return
end
