; Null hypothesis 2 of mdiv mesoscale diversity. correlations between 
; measures of diversity and other ecosystem parameters are the result 
; of analytical chance introduced by the k-means algorithm. To test 
; this, the following script finds the correlation for alpha/beta and 
; the results (patch assignments) from the random seed k-means clusters.
; Alpha diversity: the number of unique genus names for each geographical 
; 1-degree grid cell.
; Beta diversity: the number of unique genus names for each geographical 
; 1-degree grid cell that do not occur in its neighboring cell, divided 
; by the total number of unique genus names (beta diversity ranges from 
; 0:1). The beta diversity of each grid cell is taken as the mean of the 
; beta diversities between each of the (n <= 8) non-null cells 8 
; surrounding it.

; 3) (under construction) the total alpha diversity of all 9 grid cells, which is compared to the alpha diversity of the center cell. This is a null hypothesis test null t the diveristy of any grid cell may be high simply because the diversity of its regional source pool is high.
pro mdiv
;
; Blow away previous files
openw,1,'out/mdiv_icorr.out'
close,1
; Write field headers
openw,1,/append,'out/mdiv_icorr.out'
printf,1,'interval,tc_p40_pcorr,tc_p40_rcorr,tc_spdiv_pcorr,tc_spdiv_rcorr,tc_c_pcorr,tc_c_rcorr,beta_p40_pcorr,beta_p40_rcorr,beta_spdiv_pcorr,beta_spdiv_rcorr,beta_c_pcorr,beta_c_rcorr,c_p40_pcorr,c_p40_rcorr'
close,1
;
openw,1,'out/mdiv.out'
close,1
; Write field headers
openw,1,/append,'out/mdiv.out'
printf,1,'interval name,x[mlon],y[mlat],(p40[mlon,mlat]/area)*10000,c[mlon,mlat],(tc[mlon,mlat]/area)*10000,beta[mlon,mlat],(spdiv[mlon,mlat]/area)*10000'
close,1
;
;Read in data
openr,1,'data/mdiv_patch.dat'
data=dblarr(14,83213)
readf,1,data
close,1
;
;openr,1,'data/cnames.dat'
openr,1,'data/gnames.dat'
;openr,1,'data/spnames.dat'
taxa=strarr(1,83213)
readf,1,taxa
close,1
;
pi=4.0*atan(1,1)
;radius of earth in km
er=double(6371)
slim=99 ; Set sample limit to 0 for normal, or 99 if doing rarefaction. Remember also to change gstring() to gstring_rare() if doing rarefaction.
nlon=360L
nlat=180L
;
; taxonomic class name
;fname='_tax_classes'
; get rid of old file
iname=['Holocene','Pleistocene','Pliocene','Late_Miocene','Middle_Miocene','Early_Miocene','Late_Oligocene','Early_Oligocene','Late_Eocene','Middle_Eocene','Early_Eocene']
;
; 10 Myr increments from 0-80 Ma
;age_size=[-1,29514,52260,56326,70606,79115,83211,106375,112635]
; Increments corresponding to geologic intervals from Holocene through Eocene
age_size=[-1,1455,12821,22126,29681,42969,52897,55703,62358,70633,79115,82040]
;
; step size
stsz=1
;
num=0
;for i=0,40,(stsz*10) do begin
for i=0,10 do begin
   print,'Searching '+iname[num]
;ma_mid,latdec,londec,depth,pct_sand,pct_silt,pct_clay,pct_lime_mud,clust_num_10,clust_num_20,clust_num_40,clust_num_60,clust_num_80,clust_num_100,clust_num_40_t1,clust_num_40_t2,clust_num_40_t3
   lat=data[ 1,age_size[num]+1:age_size[num+stsz]+1 ]
   lon=data[ 2,age_size[num]+1:age_size[num+stsz]+1 ]
   pct_sand=data[ 3,age_size[num]+1:age_size[num+stsz]+1 ]
   pct_silt=data[ 4,age_size[num]+1:age_size[num+stsz]+1 ]
   pct_clay=data[ 5,age_size[num]+1:age_size[num+stsz]+1 ]
   pct_lmud=data[ 6,age_size[num]+1:age_size[num+stsz]+1 ]
   depth=data[ 7,age_size[num]+1:age_size[num+stsz]+1 ]
   clust_num_10=data[ 8,age_size[num]+1:age_size[num+stsz]+1 ]
   clust_num_20=data[ 9,age_size[num]+1:age_size[num+stsz]+1 ]
   clust_num_40=data[ 10,age_size[num]+1:age_size[num+stsz]+1 ]
   clust_num_60=data[ 11,age_size[num]+1:age_size[num+stsz]+1 ]
   clust_num_80=data[ 12,age_size[num]+1:age_size[num+stsz]+1 ]
   clust_num_100=data[ 13,age_size[num]+1:age_size[num+stsz]+1 ]
   names=taxa[ 0,age_size[num]+1:age_size[num+stsz]+1 ]
   x=dindgen(nlon)-179.5
   y=dindgen(nlat)-89.5
   zc=lonarr(nlon,nlat)
   tc=lonarr(nlon,nlat)
   bd=lonarr(nlon,nlat)
   betai=dblarr(8)
   beta=dblarr(nlon,nlat)
   c=lonarr(nlon,nlat)
   spdiv=lonarr(nlon,nlat)
   p10=lonarr(nlon,nlat)
   p20=lonarr(nlon,nlat)
   p40=lonarr(nlon,nlat)
   f_moment=dblarr(5,nlon,nlat)
   p60=lonarr(nlon,nlat)
   p80=lonarr(nlon,nlat)
   p100=lonarr(nlon,nlat)
   sand_mean=dblarr(nlon,nlat)
   silt_mean=dblarr(nlon,nlat)
   clay_mean=dblarr(nlon,nlat)
   lmud_mean=dblarr(nlon,nlat)
   drange=dblarr(nlon,nlat)
   dmean=dblarr(nlon,nlat)
   for mlon=0,nlon-1 do begin
      for mlat=0,nlat-1 do begin
         ttmp = gstring_rare(lon,lat,names,x[mlon],y[mlat])
         ;
         idx=where(lat ge y[mlat]-0.5 and lat lt y[mlat]+0.5 and lon ge x[mlon]-0.5 and lon lt x[mlon]+0.5,cnt)
         zc[mlon,mlat] = cnt ;zc is the number of observations
         if cnt gt slim then begin
            tc[mlon,mlat]=n_elements(ttmp) ;tc is the number of unique genus/class names
            ;print,'ZC,TC',zc[mlon,mlat],tc[mlon,mlat]
            ctemp_10=clust_num_10[idx]
            ctemp_20=clust_num_20[idx]
            ctemp_40=clust_num_40[idx]
            ctemp_60=clust_num_60[idx]
            ctemp_80=clust_num_80[idx]
            ctemp_100=clust_num_100[idx]
            p10[mlon,mlat]=n_elements(ctemp_10[uniq(ctemp_10, sort(ctemp_10))])
            p20[mlon,mlat]=n_elements(ctemp_20[uniq(ctemp_20, sort(ctemp_20))])
            p40[mlon,mlat]=n_elements(ctemp_40[uniq(ctemp_40, sort(ctemp_40))])
;;; HABITAT TYPE DISTRIBUTION PER ASSEMBLAGE
f=intarr(40)
for j=1,40 do begin
  dumb=where(ctemp_40 eq j,ftmp)
  f[j-1]=ftmp
endfor
f_moment[0:3,mlon,mlat]=moment(f,/double,sdev=sdev)
f_moment[4,mlon,mlat]=sdev
;;;
            p60[mlon,mlat]=n_elements(ctemp_60[uniq(ctemp_60, sort(ctemp_60))])
            p80[mlon,mlat]=n_elements(ctemp_80[uniq(ctemp_80, sort(ctemp_60))])
            p100[mlon,mlat]=n_elements(ctemp_100[uniq(ctemp_100, sort(ctemp_60))])
            sand_mean[mlon,mlat]=mean(pct_sand[idx])
            silt_mean[mlon,mlat]=mean(pct_silt[idx])
            clay_mean[mlon,mlat]=mean(pct_clay[idx])
            lmud_mean[mlon,mlat]=mean(pct_lmud[idx])
            drange[mlon,mlat]=max(depth[idx])-min(depth[idx])
            dmean[mlon,mlat]=mean(depth[idx])
            ; The following routine determines the beta-diversity 
            ; (difference) between each 1-square-degree-cell and the 
            ; 8 cells surrounding it. Cells that occur on any 
            ; of the four boundaries are without a neighboring cell
            ; on either one or two sides and are therefore compared to 
            ; cells back at the beginning. For example, a cell with 
            ; longitude from -179 to -180 is compared to its counterpart 
            ; with longitude from 179 to 180. A cell at -89 to -90 
            ; latitude is compared to its counterpart at 89 to 90 
            ; latitude. Below is a grid that illustrates this method
            ; where ! is the cell of interest. Its diversity count 
            ; is compared to each of the 8 cells around it and its beta
            ; diversity is taken to be the mean of all (up to 8) of 
            ; its beta (difference) diversities provided the neighboring
            ; cell is populated by at least one occurrence.
            ;
            ; NW N NE
            ; W  !  E
            ; SW S SE
            ;
            for j=0,7 do begin
               ; Choose the lon/lat indices (iqlon,iqlat) to query for unique
               ; genus/class names
               if j lt 3 then begin
                  ; N
                  if mlat eq 0 then iqlat=nlat-1 else iqlat=mlat+1
               endif else begin
                  if j lt 5 then begin
                     iqlat = mlat
                  endif else begin
                     ; S
                     if mlat eq nlat-1 then iqlat = 0 else iqlat = mlat-1
                  endelse
               endelse
               if j eq 0 or j eq 3 or j eq 5 then begin
                  ; W
                  if mlon eq 0 then iqlon=nlon-1 else iqlon=mlon-1
               endif else begin
                  if j eq 1 or j eq 6 then begin
                     iqlon = mlon
                  endif else begin
                     ; E
                     if mlon eq nlon-1 then iqlon = 0 else iqlon = mlon+1
                  endelse
               endelse
               ; Query for unique vectors of genus/class names
               case j of
                  ; NW
                  0: ttmp_nw = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
                  ; N
                  1: ttmp_n = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
                  ; NE
                  2: ttmp_ne = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
                  ; W
                  3: ttmp_w = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
                  ; E
                  4: ttmp_e = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
                  ; SW
                  5: ttmp_sw = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
                  ; S
                  6: ttmp_s = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
                  ; SE
                  7: ttmp_se = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
               endcase
            endfor
            ; Compute equation for beta diversity
            for j=0,7 do begin
               case j of
                  0: ttmp_cmp = [ttmp,ttmp_nw]
                  1: ttmp_cmp = [ttmp,ttmp_n]
                  2: ttmp_cmp = [ttmp,ttmp_ne]
                  3: ttmp_cmp = [ttmp,ttmp_w]
                  4: ttmp_cmp = [ttmp,ttmp_e]
                  5: ttmp_cmp = [ttmp,ttmp_sw]
                  6: ttmp_cmp = [ttmp,ttmp_s]
                  7: ttmp_cmp = [ttmp,ttmp_se]
               endcase
               gidx = where(ttmp_cmp eq '',tcnt)
               if tcnt eq 0 then begin
                  ; the combined list of genus names in ttmp_cmp 
                  ; (tc_cmp/2 is equivalent to Whittaker's variable 'S^bar')
                  tc_cmp = n_elements(ttmp_cmp)
                  ; the combined list of unique genus names in ttmp_cmp 
                  ; (Whittaker's variable 'Sc')
                  uttmp_cmp = ttmp_cmp[uniq(ttmp_cmp, sort(ttmp_cmp))]
                  betai[j] = ( double(n_elements(uttmp_cmp)) / double(tc_cmp / 2.0 ) ) - 1
               endif else begin
                  betai[j] = 0
               endelse
            endfor
            ;beta[mlon,mlat] = mean(betai,/double)
            idx=where(betai ne 0.,cnt)
            ; Connectivity: the number of grid cells with data or the 
            ; spatial continuity of the area
            if (cnt gt 0) then c[mlon,mlat]=cnt
            ; Beta diversity: the mean beta diversity of all non-zero cells
            if (cnt gt 0) then beta[mlon,mlat]=mean(betai(idx),/DOUBLE) else beta[mlon,mlat]=mean(betai,/DOUBLE)
            ; Find source pool diversity (excluding the grid cell of interest)
            ttmp_spi=[ ttmp_nw,ttmp_n,ttmp_ne,ttmp_w,ttmp_e,ttmp_sw,ttmp_s,ttmp_se ]
            ttmp_sp=n_elements(uniq(ttmp_spi, sort(ttmp_spi)))
            spdiv[mlon,mlat]=ttmp_sp
            ;
         endif else begin
            ; If no data in this gridcell, set tc, beta, spdiv to zero.
            tc[mlon,mlat]=0
            beta[mlon,mlat]=0
            spdiv[mlon,mlat]=0
         endelse
         ; For all grid cells where data is present print each diversity measure to file
         if tc[mlon,mlat] gt 0 then begin
            ;print,strtrim(string(i),2),' ',strtrim(string(i+(stsz*10)),2),x[mlon],y[mlat],p40[mlon,mlat],tc[mlon,mlat],beta[mlon,mlat],spdiv[mlon,mlat],double(n_elements(ttmp_cmp[uniq(ttmp_cmp, sort(ttmp_cmp))])),n_elements(ttmp_cmp)
            ;print,'Patchiness',x[mlon],y[mlat],n_elements(ttmp_cmp[where(ttmp_cmp gt 0)])
            area=(pi/180)*(er^2)*abs(sin(y[mlat]*(pi/180))-sin((y[mlat]+1)*(pi/180)))*abs(x[mlon]-(x[mlon]+1))
            ;print to file each diversity index normalized to 10000 km^2
            openw,1,/append,'out/mdiv.out'
            printf,1,format='(a17,i4,i4,f9.1,f6.3,f9.1,f6.3,f9.1)',iname[num],x[mlon],y[mlat],(p40[mlon,mlat]/area)*10000,c[mlon,mlat],(tc[mlon,mlat]/area)*10000,beta[mlon,mlat],(spdiv[mlon,mlat]/area)*10000
            close,1
         endif
      endfor ; mlat
   endfor ; mlon
   ;
   ; Analyze only the non-zero grid cells
   idx=where(tc gt 0,cnt)
   f_tmp=f_moment[0,*,*]
   ;print,mean(f_tmp[idx])
   f_tmp=f_moment[1,*,*]
   ;print,mean(f_tmp[idx])
   f_tmp=f_moment[2,*,*]
   ;print,mean(f_tmp[idx])
   f_tmp=f_moment[3,*,*]
   ;print,mean(f_tmp[idx])
   f_tmp=f_moment[4,*,*]
   ;print,mean(f_tmp[idx])
   tc=tc[idx]
   beta=beta[idx]
   c=c[idx]
   p10=p10[idx]
   p20=p20[idx]
   p40=p40[idx]
   p60=p60[idx]
   p80=p80[idx]
   p100=p100[idx]
   spdiv=spdiv[idx]
   drange=drange[idx]
   dmean=dmean[idx]
   sand_mean=sand_mean[idx]
   silt_mean=silt_mean[idx]
   clay_mean=clay_mean[idx]
   lmud_mean=lmud_mean[idx]
   max_tc=max(tc,min=min_tc)
   max_p40=max(p40,min=min_p40)
   ; Pearson correlations
   tc_p10_pcorr=correlate(tc,p10,/double)
   tc_p20_pcorr=correlate(tc,p20,/double)
   tc_p40_pcorr=correlate(tc,p40,/double)
   tc_p60_pcorr=correlate(tc,p60,/double)
   tc_p80_pcorr=correlate(tc,p80,/double)
   tc_p100_pcorr=correlate(tc,p100,/double)
   tc_beta_pcorr=correlate(tc,beta,/double)
   tc_drange_pcorr=correlate(tc,drange,/double)
   tc_spdiv_pcorr=correlate(tc,spdiv,/double)
   tc_c_pcorr=correlate(tc,c,/double)
   tc_drange_pcorr=correlate(tc,drange,/double)
   tc_dmean_pcorr=correlate(tc,dmean,/double)
   tc_sand_mean_pcorr=correlate(tc,sand_mean,/double)
   tc_silt_mean_pcorr=correlate(tc,silt_mean,/double)
   tc_clay_mean_pcorr=correlate(tc,clay_mean,/double)
   tc_lmud_mean_pcorr=correlate(tc,lmud_mean,/double)
   beta_p10_pcorr=correlate(beta,p10,/double)
   beta_p20_pcorr=correlate(beta,p20,/double)
   beta_p40_pcorr=correlate(beta,p40,/double)
   beta_p60_pcorr=correlate(beta,p60,/double)
   beta_p80_pcorr=correlate(beta,p80,/double)
   beta_p100_pcorr=correlate(beta,p100,/double)
   beta_spdiv_pcorr=correlate(beta,spdiv,/double)
   beta_c_pcorr=correlate(beta,c,/double)
   beta_drange_pcorr=correlate(beta,drange,/double)
   beta_dmean_pcorr=correlate(beta,dmean,/double)
   beta_sand_mean_pcorr=correlate(beta,sand_mean,/double)
   beta_silt_mean_pcorr=correlate(beta,silt_mean,/double)
   beta_clay_mean_pcorr=correlate(beta,clay_mean,/double)
   beta_lmud_mean_pcorr=correlate(beta,lmud_mean,/double)
   c_p40_pcorr=correlate(c,p40,/double)
   c_spdiv_pcorr=correlate(c,spdiv,/double)
   ; Spearman correlations
   tc_p10_rcorr=r_correlate(tc,p10)
   tc_p20_rcorr=r_correlate(tc,p20)
   tc_p40_rcorr=r_correlate(tc,p40)
   tc_p60_rcorr=r_correlate(tc,p60)
   tc_p80_rcorr=r_correlate(tc,p80)
   tc_p100_rcorr=r_correlate(tc,p100)
   tc_spdiv_rcorr=r_correlate(tc,spdiv)
   tc_c_rcorr=r_correlate(tc,c)
   tc_drange_rcorr=r_correlate(tc,drange)
   tc_dmean_rcorr=r_correlate(tc,dmean)
   tc_sand_mean_rcorr=r_correlate(tc,sand_mean)
   tc_silt_mean_rcorr=r_correlate(tc,silt_mean)
   tc_clay_mean_rcorr=r_correlate(tc,clay_mean)
   tc_lmud_mean_rcorr=r_correlate(tc,lmud_mean)
   beta_p10_rcorr=r_correlate(beta,p10)
   beta_p20_rcorr=r_correlate(beta,p20)
   beta_p40_rcorr=r_correlate(beta,p40)
   beta_p60_rcorr=r_correlate(beta,p60)
   beta_p80_rcorr=r_correlate(beta,p80)
   beta_p100_rcorr=r_correlate(beta,p100)
   beta_spdiv_rcorr=r_correlate(beta,spdiv)
   beta_c_rcorr=r_correlate(beta,c)
   beta_drange_rcorr=r_correlate(beta,drange)
   beta_dmean_rcorr=r_correlate(beta,dmean)
   beta_sand_mean_rcorr=r_correlate(beta,sand_mean)
   beta_silt_mean_rcorr=r_correlate(beta,silt_mean)
   beta_clay_mean_rcorr=r_correlate(beta,clay_mean)
   beta_lmud_mean_rcorr=r_correlate(beta,lmud_mean)
   c_p40_rcorr=r_correlate(c,p40)
   c_spdiv_rcorr=r_correlate(c,spdiv)
   ;
   ; write data
   print,'Writing '+iname[num]+' data to file'
   openw,1,/append,'out/mdiv_icorr.out'
   printf,1,format='(a17,f7.3,f7.3,f7.3,f7.3,f7.3,f7.3,f7.3,f7.3,f7.3,f7.3,f7.3,f7.3,f7.3,f7.3)',iname[num],tc_p40_pcorr,tc_p40_rcorr,tc_spdiv_pcorr,tc_spdiv_rcorr,tc_c_pcorr,tc_c_rcorr,beta_p40_pcorr,beta_p40_rcorr,beta_spdiv_pcorr,beta_spdiv_rcorr,beta_c_pcorr,beta_c_rcorr,c_p40_pcorr,c_p40_rcorr
   close,1
   ;
   num=num+1
endfor
;
;
print,'Searching entire Cenozoic'
lat=data[ 1,* ]
lon=data[ 2,* ]
pct_sand=data[ 3,* ]
pct_silt=data[ 4,* ]
pct_clay=data[ 5,* ]
pct_lmud=data[ 6,* ]
depth=data[ 7,* ]
clust_num_10=data[ 8,* ]
clust_num_20=data[ 9,* ]
clust_num_40=data[ 10,* ]
clust_num_60=data[ 11,* ]
clust_num_80=data[ 12,* ]
clust_num_100=data[ 13,* ]
names=taxa[ 0,* ]
x=dindgen(nlon)-179.5
y=dindgen(nlat)-89.5
zc=lonarr(nlon,nlat)
tc=lonarr(nlon,nlat)
bd=lonarr(nlon,nlat)
betai=dblarr(8)
beta=dblarr(nlon,nlat)
c=lonarr(nlon,nlat)
spdiv=lonarr(nlon,nlat)
p10=lonarr(nlon,nlat)
p20=lonarr(nlon,nlat)
p40=lonarr(nlon,nlat)
p60=lonarr(nlon,nlat)
p80=lonarr(nlon,nlat)
p100=lonarr(nlon,nlat)
sand_mean=dblarr(nlon,nlat)
silt_mean=dblarr(nlon,nlat)
clay_mean=dblarr(nlon,nlat)
lmud_mean=dblarr(nlon,nlat)
drange=dblarr(nlon,nlat)
dmean=dblarr(nlon,nlat)
for mlon=0,nlon-1 do begin
   for mlat=0,nlat-1 do begin
      ttmp = gstring_rare(lon,lat,names,x[mlon],y[mlat])
      ;
      ;;;tc is the number of unique genus/class names
      idx=where(lat ge y[mlat]-0.5 and lat lt y[mlat]+0.5 and lon ge x[mlon]-0.5 and lon lt x[mlon]+0.5,cnt)
      ;;;zc is the number of observations
      zc[mlon,mlat] = cnt
      if cnt gt slim then begin
         tc[mlon,mlat]=n_elements(ttmp)
         ;print,'ZC,TC',zc[mlon,mlat],tc[mlon,mlat]
         ctemp_10=clust_num_10[idx]
         ctemp_20=clust_num_20[idx]
         ctemp_40=clust_num_40[idx]
         ctemp_60=clust_num_60[idx]
         ctemp_80=clust_num_80[idx]
         ctemp_100=clust_num_100[idx]
         p10[mlon,mlat]=n_elements(ctemp_10[uniq(ctemp_10, sort(ctemp_10))])
         p20[mlon,mlat]=n_elements(ctemp_20[uniq(ctemp_20, sort(ctemp_20))])
         p40[mlon,mlat]=n_elements(ctemp_40[uniq(ctemp_40, sort(ctemp_40))])
         p60[mlon,mlat]=n_elements(ctemp_60[uniq(ctemp_60, sort(ctemp_60))])
         p80[mlon,mlat]=n_elements(ctemp_80[uniq(ctemp_80, sort(ctemp_60))])
         p100[mlon,mlat]=n_elements(ctemp_100[uniq(ctemp_100, sort(ctemp_60))])
         sand_mean[mlon,mlat]=mean(pct_sand[idx])
         silt_mean[mlon,mlat]=mean(pct_silt[idx])
         clay_mean[mlon,mlat]=mean(pct_clay[idx])
         lmud_mean[mlon,mlat]=mean(pct_lmud[idx])
         drange[mlon,mlat]=max(depth[idx])-min(depth[idx])
         dmean[mlon,mlat]=mean(depth[idx])
         ; The following routine determines the beta-diversity 
         ; (difference) between each 1-square-degree-cell and the 
         ; 8 cells surrounding it. Cells that occur on any 
         ; of the four boundaries are without a neighboring cell
         ; on either one or two sides and are therefore compared to 
         ; cells back at the beginning. For example, a cell with 
         ; longitude from -179 to -180 is compared to its counterpart 
         ; with longitude from 179 to 180. A cell at -89 to -90 
         ; latitude is compared to its counterpart at 89 to 90 
         ; latitude. Below is a grid that illustrates this method
         ; where ! is the cell of interest. Its diversity count 
         ; is compared to each of the 8 cells around it and its beta
         ; diversity is taken to be the mean of all (up to 8) of 
         ; its beta (difference) diversities provided the neighboring
         ; cell is populated by at least one occurrence.
         ;
         ; NW N NE
         ; W  !  E
         ; SW S SE
         ;
         for j=0,7 do begin
            ; Choose the lon/lat indices (iqlon,iqlat) to query for unique
            ; genus/class names
            if j lt 3 then begin
               ; N
               if mlat eq 0 then iqlat=nlat-1 else iqlat=mlat+1
            endif else begin
               if j lt 5 then begin
                  iqlat = mlat
               endif else begin
                  ; S
                  if mlat eq nlat-1 then iqlat = 0 else iqlat = mlat-1
               endelse
            endelse
            if j eq 0 or j eq 3 or j eq 5 then begin
               ; W
               if mlon eq 0 then iqlon=nlon-1 else iqlon=mlon-1
            endif else begin
               if j eq 1 or j eq 6 then begin
                  iqlon = mlon
               endif else begin
                  ; E
                  if mlon eq nlon-1 then iqlon = 0 else iqlon = mlon+1
               endelse
            endelse
            ; Query for unique vectors of genus/class names
            case j of
               ; NW
               0: ttmp_nw = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
               ; N
               1: ttmp_n = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
               ; NE
               2: ttmp_ne = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
               ; W
               3: ttmp_w = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
               ; E
               4: ttmp_e = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
               ; SW
               5: ttmp_sw = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
               ; S
               6: ttmp_s = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
               ; SE
               7: ttmp_se = gstring_rare(lon,lat,names,x[iqlon],y[iqlat])
            endcase
         endfor
         ; Compute equation for beta diversity
         for j=0,7 do begin
            case j of
               0: ttmp_cmp = [ttmp,ttmp_nw]
               1: ttmp_cmp = [ttmp,ttmp_n]
               2: ttmp_cmp = [ttmp,ttmp_ne]
               3: ttmp_cmp = [ttmp,ttmp_w]
               4: ttmp_cmp = [ttmp,ttmp_e]
               5: ttmp_cmp = [ttmp,ttmp_sw]
               6: ttmp_cmp = [ttmp,ttmp_s]
               7: ttmp_cmp = [ttmp,ttmp_se]
            endcase
            gidx = where(ttmp_cmp eq '',tcnt)
            if tcnt eq 0 then begin
               ; the combined list of genus names in ttmp_cmp 
               ; (tc_cmp/2 is equivalent to Whittaker's variable 'S^bar')
               tc_cmp = n_elements(ttmp_cmp)
               ; the combined list of unique genus names in ttmp_cmp 
               ; (Whittaker's variable 'Sc')
               uttmp_cmp = ttmp_cmp[uniq(ttmp_cmp, sort(ttmp_cmp))]
               betai[j] = ( double(n_elements(uttmp_cmp)) / double(tc_cmp / 2.0 ) ) - 1
            endif else begin
               betai[j] = 0
            endelse
         endfor
         ;beta[mlon,mlat] = mean(betai,/double)
         idx=where(betai ne 0.,cnt)
         ; Connectivity: the number of grid cells with data or the 
         ; spatial continuity of the area
         if (cnt gt 0) then c[mlon,mlat]=cnt
         ; Beta diversity: the mean beta diversity of all non-zero cells
         if (cnt gt 0) then beta[mlon,mlat]=mean(betai(idx),/DOUBLE) else beta[mlon,mlat]=mean(betai,/DOUBLE)
         ; Find source pool diversity (excluding the grid cell of interest)
         ttmp_spi=[ ttmp_nw,ttmp_n,ttmp_ne,ttmp_w,ttmp_e,ttmp_sw,ttmp_s,ttmp_se ]
         ttmp_sp=n_elements(uniq(ttmp_spi, sort(ttmp_spi)))
         spdiv[mlon,mlat]=ttmp_sp
         ;
      endif else begin
         ; If no data in this gridcell, set tc, beta, spdiv to zero.
         tc[mlon,mlat]=0
         beta[mlon,mlat]=0
         spdiv[mlon,mlat]=0
      endelse
   endfor ; mlat
endfor ; mlon
;
; Analyze only the non-zero grid cells
idx=where(tc gt 0,cnt)
tc=tc[idx]
beta=beta[idx]
c=c[idx]
p10=p10[idx]
p20=p20[idx]
p40=p40[idx]
p60=p60[idx]
p80=p80[idx]
p100=p100[idx]
spdiv=spdiv[idx]
drange=drange[idx]
dmean=dmean[idx]
sand_mean=sand_mean[idx]
silt_mean=silt_mean[idx]
clay_mean=clay_mean[idx]
lmud_mean=lmud_mean[idx]
max_tc=max(tc,min=min_tc)
max_p40=max(p40,min=min_p40)
; Pearson correlations
tc_p10_pcorr=correlate(tc,p10,/double)
tc_p20_pcorr=correlate(tc,p20,/double)
tc_p40_pcorr=correlate(tc,p40,/double)
tc_p60_pcorr=correlate(tc,p60,/double)
tc_p80_pcorr=correlate(tc,p80,/double)
tc_p100_pcorr=correlate(tc,p100,/double)
tc_spdiv_pcorr=correlate(tc,spdiv,/double)
tc_c_pcorr=correlate(tc,c,/double)
tc_drange_pcorr=correlate(tc,drange,/double)
tc_dmean_pcorr=correlate(tc,dmean,/double)
tc_sand_mean_pcorr=correlate(tc,sand_mean,/double)
tc_silt_mean_pcorr=correlate(tc,silt_mean,/double)
tc_clay_mean_pcorr=correlate(tc,clay_mean,/double)
tc_lmud_mean_pcorr=correlate(tc,lmud_mean,/double)
beta_p10_pcorr=correlate(beta,p10,/double)
beta_p20_pcorr=correlate(beta,p20,/double)
beta_p40_pcorr=correlate(beta,p40,/double)
beta_p60_pcorr=correlate(beta,p60,/double)
beta_p80_pcorr=correlate(beta,p80,/double)
beta_p100_pcorr=correlate(beta,p100,/double)
beta_spdiv_pcorr=correlate(beta,spdiv,/double)
beta_c_pcorr=correlate(beta,c,/double)
beta_drange_pcorr=correlate(beta,drange,/double)
beta_dmean_pcorr=correlate(beta,dmean,/double)
beta_sand_mean_pcorr=correlate(beta,sand_mean,/double)
beta_silt_mean_pcorr=correlate(beta,silt_mean,/double)
beta_clay_mean_pcorr=correlate(beta,clay_mean,/double)
beta_lmud_mean_pcorr=correlate(beta,lmud_mean,/double)
c_p40_pcorr=correlate(c,p40,/double)
c_spdiv_pcorr=correlate(c,spdiv,/double)
; Spearman correlations
tc_p10_rcorr=r_correlate(tc,p10)
tc_p20_rcorr=r_correlate(tc,p20)
tc_p40_rcorr=r_correlate(tc,p40)
tc_p60_rcorr=r_correlate(tc,p60)
tc_p80_rcorr=r_correlate(tc,p80)
tc_p100_rcorr=r_correlate(tc,p100)
tc_spdiv_rcorr=r_correlate(tc,spdiv)
tc_c_rcorr=r_correlate(tc,c)
tc_drange_rcorr=r_correlate(tc,drange)
tc_dmean_rcorr=r_correlate(tc,dmean)
tc_sand_mean_rcorr=r_correlate(tc,sand_mean)
tc_silt_mean_rcorr=r_correlate(tc,silt_mean)
tc_clay_mean_rcorr=r_correlate(tc,clay_mean)
tc_lmud_mean_rcorr=r_correlate(tc,lmud_mean)
beta_p10_rcorr=r_correlate(beta,p10)
beta_p20_rcorr=r_correlate(beta,p20)
beta_p40_rcorr=r_correlate(beta,p40)
beta_p60_rcorr=r_correlate(beta,p60)
beta_p80_rcorr=r_correlate(beta,p80)
beta_p100_rcorr=r_correlate(beta,p100)
beta_spdiv_rcorr=r_correlate(beta,spdiv)
beta_c_rcorr=r_correlate(beta,c)
beta_drange_rcorr=r_correlate(beta,drange)
beta_dmean_rcorr=r_correlate(beta,dmean)
beta_sand_mean_rcorr=r_correlate(beta,sand_mean)
beta_silt_mean_rcorr=r_correlate(beta,silt_mean)
beta_clay_mean_rcorr=r_correlate(beta,clay_mean)
beta_lmud_mean_rcorr=r_correlate(beta,lmud_mean)
c_p40_rcorr=r_correlate(c,p40)
c_spdiv_rcorr=r_correlate(c,spdiv)
print,'Max/Min TC',max_tc,min_tc
print,'BETA',n_elements(beta),n_elements(beta[where(beta gt 0)])
print,'Max/Min Patches_40',max_p40,min_p40
print,'MAX/MIN Connectivity',max(c),min(c)
print,''
print,'Pearson Corr: Alpha Div/Patch10',tc_p10_pcorr
print,'Pearson Corr: Alpha Div/Patch20',tc_p20_pcorr
print,'Pearson Corr: Alpha Div/Patch40',tc_p40_pcorr
print,'Pearson Corr: Alpha Div/Patch60',tc_p60_pcorr
print,'Pearson Corr: Alpha Div/Patch80',tc_p80_pcorr
print,'Pearson Corr: Alpha Div/Patch100',tc_p100_pcorr
print,'Pearson Corr: Alpha Div/Src Pool Div.',tc_spdiv_pcorr
print,'Pearson Corr: Alpha Div/Drange',tc_drange_pcorr
print,'Pearson Corr: Alpha Div/Dmean',tc_dmean_pcorr
print,'Pearson Corr: Alpha Div/Mean Sand Pct',tc_sand_mean_pcorr
print,'Pearson Corr: Alpha Div/Mean Silt Pct',tc_silt_mean_pcorr
print,'Pearson Corr: Alpha Div/Mean Clay Pct',tc_clay_mean_pcorr
print,'Pearson Corr: Alpha Div/Mean Lime Mud Pct',tc_lmud_mean_pcorr
print,'Pearson Corr: Beta Div/Patch10',beta_p10_pcorr
print,'Pearson Corr: Beta Div/Patch20',beta_p20_pcorr
print,'Pearson Corr: Beta Div/Patch40',beta_p40_pcorr
print,'Pearson Corr: Beta Div/Patch60',beta_p60_pcorr
print,'Pearson Corr: Beta Div/Patch80',beta_p80_pcorr
print,'Pearson Corr: Beta Div/Patch100',beta_p100_pcorr
print,'Pearson Corr: Beta Div/Src Pool Div.',beta_spdiv_pcorr
print,'Pearson Corr: Beta Div/Drange',beta_drange_pcorr
print,'Pearson Corr: Beta Div/Dmean',beta_dmean_pcorr
print,'Pearson Corr: Beta Div/Mean Sand Pct',beta_sand_mean_pcorr
print,'Pearson Corr: Beta Div/Mean Silt Pct',beta_silt_mean_pcorr
print,'Pearson Corr: Beta Div/Mean Clay Pct',beta_clay_mean_pcorr
print,'Pearson Corr: Beta Div/Mean Lime Mud Pct',beta_lmud_mean_pcorr
print,'Pearson Corr: Connectivity/Alpha Div',tc_c_pcorr
print,'Pearson Corr: Connectivity/Beta Div',beta_c_pcorr
print,'Pearson Corr: Connectivity/Patch40',c_p40_pcorr
print,'Pearson Corr: Connectivity/Src Pool Div',c_spdiv_pcorr
print,'Spearman Corr: Alpha Div/Patch10',tc_p10_rcorr
print,'Spearman Corr: Alpha Div/Patch20',tc_p20_rcorr
print,'Spearman Corr: Alpha Div/Patch40',tc_p40_rcorr
print,'Spearman Corr: Alpha Div/Patch60',tc_p60_rcorr
print,'Spearman Corr: Alpha Div/Patch80',tc_p80_rcorr
print,'Spearman Corr: Alpha Div/Patch100',tc_p100_rcorr
print,'Spearman Corr: Alpha Div/Src Pool Div.',tc_spdiv_rcorr
print,'Spearman Corr: Alpha Div/Drange',tc_drange_rcorr
print,'Spearman Corr: Alpha Div/Dmean',tc_dmean_rcorr
print,'Spearman Corr: Alpha Div/Mean Sand Pct',tc_sand_mean_rcorr
print,'Spearman Corr: Alpha Div/Mean Silt Pct',tc_silt_mean_rcorr
print,'Spearman Corr: Alpha Div/Mean Clay Pct',tc_clay_mean_rcorr
print,'Spearman Corr: Alpha Div/Mean Lime Mud Pct',tc_lmud_mean_rcorr
print,'Spearman Corr: Beta Div/Patch10',beta_p10_rcorr
print,'Spearman Corr: Beta Div/Patch20',beta_p20_rcorr
print,'Spearman Corr: Beta Div/Patch40',beta_p40_rcorr
print,'Spearman Corr: Beta Div/Patch60',beta_p60_rcorr
print,'Spearman Corr: Beta Div/Patch80',beta_p80_rcorr
print,'Spearman Corr: Beta Div/Patch100',beta_p100_rcorr
print,'Spearman Corr: Beta Div/Src Pool Div.',beta_spdiv_rcorr
print,'Spearman Corr: Beta Div/Drange',beta_drange_rcorr
print,'Spearman Corr: Beta Div/Dmean',beta_dmean_rcorr
print,'Spearman Corr: Beta Div/Mean Sand Pct',beta_sand_mean_rcorr
print,'Spearman Corr: Beta Div/Mean Silt Pct',beta_silt_mean_rcorr
print,'Spearman Corr: Beta Div/Mean Clay Pct',beta_clay_mean_rcorr
print,'Spearman Corr: Beta Div/Mean Lime Mud Pct',beta_lmud_mean_rcorr
print,'Spearman Corr: Connectivity/Alpha Div',tc_c_rcorr
print,'Spearman Corr: Connectivity/Beta Div',beta_c_rcorr
print,'Spearman Corr: Connectivity/Patch40',c_p40_rcorr
print,'Spearman Corr: Connectivity/Src Pool Div',c_spdiv_rcorr
; write data
openw,1,'out/mdiv_cen_corr.out'
printf,1,'p10',format='(f6.3,f6.3,f6.3,f6.3)',tc_p10_pcorr,tc_p10_rcorr,beta_p10_pcorr,beta_p10_rcorr
printf,1,'p20',format='(f6.3,f6.3,f6.3,f6.3)',tc_p20_pcorr,tc_p20_rcorr,beta_p20_pcorr,beta_p20_rcorr
printf,1,'p40',format='(f6.3,f6.3,f6.3,f6.3,f6.3,f6.3)',tc_p40_pcorr,tc_p40_rcorr,beta_p40_pcorr,beta_p40_rcorr,c_p40_pcorr,c_p40_rcorr
printf,1,'p60',format='(f6.3,f6.3,f6.3,f6.3)',tc_p60_pcorr,tc_p60_rcorr,beta_p60_pcorr,beta_p60_rcorr
printf,1,'p80',format='(f6.3,f6.3,f6.3,f6.3)',c_p80_pcorr,tc_p80_rcorr,beta_p80_pcorr,beta_p80_rcorr
printf,1,'p100',format='(f6.3,f6.3,f6.3,f6.3)',c_p100_pcorr,tc_p100_rcorr,beta_p100_pcorr,beta_p100_rcorr
printf,1,'spdiv',format='(f6.3,f6.3,f6.3,f6.3,f6.3,f6.3)',c_spdiv_pcorr,tc_spdiv_rcorr,beta_spdiv_pcorr,beta_spdiv_rcorr,c_spdiv_pcorr,c_spdiv_rcorr
printf,1,'c',format='(f6.3,f6.3,f6.3,f6.3)',c_c_pcorr,tc_c_rcorr,beta_c_pcorr,beta_c_rcorr
printf,1,'dmean',format='(f6.3,f6.3,f6.3,f6.3)',c_dmean_pcorr,tc_dmean_rcorr,beta_dmean_pcorr,beta_dmean_rcorr
printf,1,'drange',format='(f6.3,f6.3,f6.3,f6.3)',c_drange_pcorr,tc_drange_rcorr,beta_drange_pcorr,beta_drange_rcorr
printf,1,'sand_mean',format='(f6.3,f6.3,f6.3,f6.3)',c_sand_mean_pcorr,tc_sand_mean_rcorr,beta_sand_mean_pcorr,beta_sand_mean_rcorr
printf,1,'silt_mean',format='(f6.3,f6.3,f6.3,f6.3)',c_silt_mean_pcorr,tc_silt_mean_rcorr,beta_silt_mean_pcorr,beta_silt_mean_rcorr
printf,1,'clay_mean',format='(f6.3,f6.3,f6.3,f6.3)',c_clay_mean_pcorr,tc_clay_mean_rcorr,beta_clay_mean_pcorr,beta_clay_mean_rcorr
printf,1,'lmud_mean',format='(f6.3,f6.3,f6.3,f6.3)',c_lmud_mean_pcorr,tc_lmud_mean_rcorr,beta_lmud_mean_pcorr,beta_lmud_mean_rcorr
close,1
;
return
end
