#!/bin/bash
###
FIG1='../images/count_map'
FIG2='../images/pca_rotated'
FIG3='../images/multi_map_adiv_habitats'
###
EVALS1=`tail -n+2 evals.out | head -n+1 |  sed 's/^ * / & /;s/ * / \& /g;s/ * $//' | awk '{printf "%s %0.1f %s %0.1f %s %0.1f %s %0.1f %s %0.1f\n", $1,$2,$3,$4,$5,$6,$7,$8,$9,$10;}'`
EVALS2=`tail -n+3 evals.out | head -n+1 |  sed 's/^ * / & /;s/ * / \& /g;s/ * $//' | awk '{printf "%s %0.1f %s %0.1f %s %0.1f %s %0.1f %s %0.1f\n", $1,$2,$3,$4,$5,$6,$7,$8,$9,$10;}'`
EVECS1=`head -n+1 evecs.out | sed 's/^ * / & /;s/ * / \& /g;s/ * $//;s/$/  \\\\ /' | awk '{printf "%s %0.3f %s %0.3f %s %0.3f %s %0.3f %s %0.3f\n", $1,$2,$3,$4,$5,$6,$7,$8,$9,$10;}'`
EVECS2=`head -n+2 evecs.out | tail -n-1 | sed 's/^ * / & /;s/ * / \& /g;s/ * $//;s/$/  \\\\ /' | awk '{printf "%s %0.3f %s %0.3f %s %0.3f %s %0.3f %s %0.3f\n", $1,$2,$3,$4,$5,$6,$7,$8,$9,$10;}'`
EVECS3=`head -n+3 evecs.out | tail -n-1 | sed 's/^ * / & /;s/ * / \& /g;s/ * $//;s/$/  \\\\ /' | awk '{printf "%s %0.3f %s %0.3f %s %0.3f %s %0.3f %s %0.3f\n", $1,$2,$3,$4,$5,$6,$7,$8,$9,$10;}'`
EVECS4=`head -n+4 evecs.out | tail -n-1 | sed 's/^ * / & /;s/ * / \& /g;s/ * $//;s/$/  \\\\ /' | awk '{printf "%s %0.3f %s %0.3f %s %0.3f %s %0.3f %s %0.3f\n", $1,$2,$3,$4,$5,$6,$7,$8,$9,$10;}'`
EVECS5=`head -n+5 evecs.out | tail -n-1 | sed 's/^ * / & /;s/ * / \& /g;s/ * $//;s/$/  \\\\ /' | awk '{printf "%s %0.3f %s %0.3f %s %0.3f %s %0.3f %s %0.3f\n", $1,$2,$3,$4,$5,$6,$7,$8,$9,$10;}'`
FNAME=pca
###
P_COEFF1=`tail -n+2 p_coeff.out | head -n+1 | sed 's/^ * //;s/ * / \& /g;s/ * $//' | awk '{printf "%s %0.3f %s %s\n", $2,$3,$4,$7;}'`
P_COEFF2=`tail -n+3 p_coeff.out | head -n+1 | sed 's/^ * //;s/ * / \& /g;s/ * $//' | awk '{printf "%s %0.3f %s %s\n", $2,$3,$4,$7;}'`
P_COEFF3=`tail -n+4 p_coeff.out | head -n+1 | sed 's/^ * //;s/ * / \& /g;s/ * $//' | awk '{printf "%s %0.3f %s %s\n", $2,$3,$4,$7;}'`
P_COEFF4=`tail -n+5 p_coeff.out | head -n+1 | sed 's/^ * //;s/ * / \& /g;s/ * $//' | awk '{printf "%s %0.3f %s %s\n", $2,$3,$4,$7;}'`
P_COEFF5=`tail -n+6 p_coeff.out | head -n+1 | sed 's/^ * //;s/ * / \& /g;s/ * $//' | awk '{printf "%s %0.3f %s %s\n", $2,$3,$4,$7;}'`
P_COEFF6=`tail -n+7 p_coeff.out | head -n+1 | sed 's/^ * //;s/ * / \& /g;s/ * $//' | awk '{printf "%s %0.3f %s %s\n", $2,$3,$4,$7;}'`
P_COEFF7=`tail -n+8 p_coeff.out | head -n+1 | sed 's/^ * //;s/ * / \& /g;s/ * $//' | awk '{printf "%s %0.3f %s %s\n", $2,$3,$4,$7;}'`
###
EVALS_COLS=`head -n+1 evals.out | sed 's/ //g;s/,/r/g;s/^/l/'`
P_COEFF_COLS=`head -n+1 p_coeff.out | sed 's/ //g;s/^,/l/;s/,/r/g'`
###
### Clean up
rm -f ${FNAME}.tex
### Tranform images
epstopdf ${FIG1}.eps
epstopdf ${FIG2}.eps
epstopdf ${FIG3}.eps
###
### Write LaTex file 
echo '\documentclass[letterpaper,12pt]{article}' >> ${FNAME}.tex
echo '\usepackage{graphicx}' >> ${FNAME}.tex
echo '\begin{document}' >> ${FNAME}.tex
cat cinzia.asc >> ${FNAME}.tex
echo '' >> ${FNAME}.tex
echo '\begin{table}[!h]' >> ${FNAME}.tex
echo '   \begin{flushleft}' >> ${FNAME}.tex
echo '   \caption[PCA Lithology]{Principal Component Analysis of Sedimentary Lithologies}' >> ${FNAME}.tex
echo '      \begin{tabular}[c]{'${EVALS_COLS}'}' >> ${FNAME}.tex
echo '\hline  \\' >> ${FNAME}.tex
echo '\multicolumn{1}{c}{} & \multicolumn{5}{c}{Factor loadings}  \\' >> ${FNAME}.tex
echo '\hline  \\' >> ${FNAME}.tex
echo 'Variable & F1 & F2 & F3 & F4 & F5  \\' >> ${FNAME}.tex
echo '\hline  \\' >> ${FNAME}.tex
echo 'Covariance '${EVALS1}'  \\'  >> ${FNAME}.tex
echo 'Tot. Covar. (in \%) '${EVALS2}'  \\' >> ${FNAME}.tex
echo 'Depth '${EVECS1}'  \\' >> ${FNAME}.tex
echo 'Pct Sand '${EVECS2}'  \\' >> ${FNAME}.tex
echo 'Pct Silt '${EVECS3}'  \\' >> ${FNAME}.tex
echo 'Pct Clay '${EVECS4}'  \\' >> ${FNAME}.tex
echo 'Pct Lime Mud '${EVECS5}'  \\' >> ${FNAME}.tex
echo '      \end{tabular}' >> ${FNAME}.tex
echo '   \label{}' >> ${FNAME}.tex
echo '   \end{flushleft}' >> ${FNAME}.tex
echo '\end{table}' >> ${FNAME}.tex
###
echo '%' >> ${FNAME}.tex
echo '\begin{table}[!h]' >> ${FNAME}.tex
echo '   \begin{flushleft}' >> ${FNAME}.tex
echo '   \caption[Correlation]{Pearson correlation of $\alpha$--diversity environmental/diversity indices}' >> ${FNAME}.tex
#echo '   \vspace{0.2cm}' >> ${FNAME}.tex
echo '      \begin{tabular}[c]{'${P_COEFF_COLS}'}' >> ${FNAME}.tex
echo '\hline  \\' >> ${FNAME}.tex
echo 'Variable & Pearson Coeff. & P--value  \\' >> ${FNAME}.tex
echo '\hline  \\' >> ${FNAME}.tex
echo 'Number of Habitats '${P_COEFF1}' \\' >> ${FNAME}.tex
echo 'Local Depth Range '${P_COEFF2}' \\' >> ${FNAME}.tex
echo 'Local Depth Mean '${P_COEFF3}' \\' >> ${FNAME}.tex
echo '$\beta$--Diversity '${P_COEFF4}' \\' >> ${FNAME}.tex
echo '      \end{tabular}' >> ${FNAME}.tex
echo '   \label{}' >> ${FNAME}.tex
echo '   \end{flushleft}' >> ${FNAME}.tex
echo '\end{table}' >> ${FNAME}.tex
###
echo '%' >> ${FNAME}.tex
echo '\begin{table}[!h]' >> ${FNAME}.tex
echo '   \begin{flushleft}' >> ${FNAME}.tex
echo '   \caption[Correlation]{Pearson correlation of $\beta$--diversity environmental/diversity indices}' >> ${FNAME}.tex
#echo '   \vspace{0.2cm}' >> ${FNAME}.tex
echo '      \begin{tabular}[c]{'${P_COEFF_COLS}'}' >> ${FNAME}.tex
echo '\hline  \\' >> ${FNAME}.tex
echo 'Variable & Pearson Coeff. & P--value  \\' >> ${FNAME}.tex
echo '\hline  \\' >> ${FNAME}.tex
echo 'Number of Habitats '${P_COEFF5}' \\' >> ${FNAME}.tex
echo 'Local Depth Range '${P_COEFF6}' \\' >> ${FNAME}.tex
echo 'Local Depth Mean '${P_COEFF7}' \\' >> ${FNAME}.tex
echo '      \end{tabular}' >> ${FNAME}.tex
echo '   \label{}' >> ${FNAME}.tex
echo '   \end{flushleft}' >> ${FNAME}.tex
echo '\end{table}' >> ${FNAME}.tex
echo '\pagebreak' >> ${FNAME}.tex
###
echo '%' >> ${FNAME}.tex
echo '\begin{figure}' >> ${FNAME}.tex
echo '  \begin{center}' >> ${FNAME}.tex
echo '  \caption[]{Illustration of $\alpha$--diversity within each geographical 1$^{\circ}$ cell. High $\alpha$--diversity corresponds to hot colors, whereas grid cells with low diversity have a corresonding cool color. Note that some of the highest observed diversities occur along the passive margin of the Southeastern United States.}' >> ${FNAME}.tex
echo '  \includegraphics[scale = 0.4]{'${FIG1}'}' >> ${FNAME}.tex
echo '  \label{'${FIG1}'}' >> ${FNAME}.tex
echo '  \end{center}' >> ${FNAME}.tex
echo '\end{figure}' >> ${FNAME}.tex
###
echo '%' >> ${FNAME}.tex
echo '\begin{figure}' >> ${FNAME}.tex
echo '  \begin{center}' >> ${FNAME}.tex
echo '  \caption[]{Ordination of 40 depositional habitats in the space of the principal factors F1 and F2}' >> ${FNAME}.tex
echo '  \includegraphics[scale = 0.5]{'${FIG2}'}' >> ${FNAME}.tex
echo '  \label{'${FIG2}'}' >> ${FNAME}.tex
echo '  \end{center}' >> ${FNAME}.tex
echo '\end{figure}' >> ${FNAME}.tex
###
echo '%' >> ${FNAME}.tex
echo '\begin{figure}' >> ${FNAME}.tex
echo '  \begin{center}' >> ${FNAME}.tex
echo '  \caption[]{Landscape of global fossil $\alpha$--diversity and the number of depositional habitats (represented by colors). Geographic location is given on the two horizontal axes, the $\alpha$--diversity of each 1$^{\circ}$ grid is represented by that grids height along the vertical axis, and the number of depositional habitats within that grid is represented by the color of the peak (abundand habitats in red and few in blue). This illustrates the correlation between $\alpha$--diversity and depositional habitats from Table 2.}' >> ${FNAME}.tex
echo '  \includegraphics[scale = 0.4]{'${FIG3}'}' >> ${FNAME}.tex
echo '  \label{'${FIG3}'}' >> ${FNAME}.tex
echo '  \end{center}' >> ${FNAME}.tex
echo '\end{figure}' >> ${FNAME}.tex
###
echo '\end{document}' >> ${FNAME}.tex
###
pdflatex ${FNAME}.tex
pdflatex ${FNAME}.tex
pdflatex ${FNAME}.tex
rm -f ${P_COEFF}.tmp* ${FNAME}.aux ${FNAME}.log ${FNAME}.tex
